package hello.jsp; 

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.ArrayList;
import org.apache.struts.action.*;

/**
 * Reads all files in messages directory or datasource and converts to JavaBean.
 * $Revision: 1.2 $ $Date: 2002/10/06 22:46:48 $ (helder@acm.org).
 */
public class ShowMessagesAction extends Action {
    
    private String successTarget = "success";
    private String failureTarget = "default";
    private String messageDir;
    
     /**
     * Reads all messages from XML files or datasource (or other media).
     */
    public ActionForward execute(ActionMapping mapping, ActionForm form, 
                                 HttpServletRequest request, HttpServletResponse response) 
                                 throws IOException, ServletException {
                                     
        try {
            MessageBeanDAO dao = (MessageBeanDAO)request.getAttribute("dao");
            MessageBean[] beanArray = dao.retrieveAll();
            request.setAttribute("messages", beanArray);
            return (mapping.findForward(successTarget));
        } catch (PersistenceException e) {
            throw new ServletException(e);   
        } 
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successTarget + "\", \"" + failureTarget + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof ShowMessagesAction) ) return false;
        ShowMessagesAction cmd = (ShowMessagesAction) obj;
        return cmd.toString().equals(toString());
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successTarget.hashCode() * failureTarget.hashCode();
    }
}
